
AdrPolice   EQU    #9E00

        ORG     #9C00
        LD      A,(AdrPolice)
        AND     A
        JR      NZ,PoliceOK
        DI
        LD      bc,#7F8A
        OUT     (c),c
        LD      hl,#3800
        LD      de,AdrPolice
        LD      bc,#800
        LDIR
        EI
PoliceOk:
        LD      H,(IX+1)
        LD      L,(IX+0)
        LD      A,(HL)
        INC     HL
        OR      (HL)
        DEC     HL
        AND     A
        JR      Z,Fin
        LD      DE,#1000
        CALL    DepkLzw
        INC     HL
        LD      (#BE80),HL
        LD      IX,#1000
Boucle:
        LD      DE,#C000
        LD      A,(IX+0)
        AND     A
        JR      Z,FIN
        INC     IX
        CP      'O'
        JR      Z,DrawImgO
        CP      'D'
        JR      Z,DrawImgD
        RET
Fin:
        LD      HL,0
        LD      (#BE80),HL
        RET

DrawImgO:
        LD      A,(IX+0)
        INC     IX
        LD      BC,AdrPolice
        LD      H,C
        LD      L,A
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,BC
        LD      B,#11
        LD      A,D
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        LD      HL,#C800
        ADD     HL,DE
        EX      DE,HL
        LD      A,D
        CP      #C7
        JR      NZ,DrawImgO
        LD      A,E
        CP      #D0
        JR      NZ,DrawImgO
        RET

DrawImgD:
        LD      C,(IX+0)
        INC     IX
        LD      B,(IX+0)
        INC     IX
DrawImgD1:
        PUSH    BC
        LD      C,(IX+0)                        ; Dplacement
        INC     IX
        LD      B,0
        EX      DE,HL
        ADD     HL,BC
        EX      DE,HL
        LD      H,B
        LD      L,(IX+0)                        ; Code ASCII
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        LD      BC,AdrPolice
        ADD     HL,BC
        LD      B,#11
        LD      A,D
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        SET     3,D
        LDI
        LD      HL,#C800
        ADD     HL,DE
        EX      DE,HL
        INC     IX
        POP     BC
        DEC     BC
        DEC     BC
        LD      A,B
        OR      C
        JR      NZ,DrawImgD1
        RET

;
; Entre :
;
;   HL = Buffer (fichier compact)
;   DE = Destination
;
; Sortie :
;
;   AF, BC, DE, HL modifis
;
;
DepkLzw:
        XOR     A
        LD      (BclLzw+1),A
BclLzw:
        LD      A,0
        RR      A                   ; Rotation avec calcul Flags C et Z
        LD      (BclLzw+1),A
        JR      Z,TstBitLzw
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw
;
TstBitLzw:
        LD      A,(HL)
        INC     HL
        RRA                         ; Rotation rapide calcul seulement flag C
        SET     7,A                 ; Positionne bit 7 en gardant flag C
        LD      (BclLzw+1),A
        JR      C,TstCodeLzw

        LDI
        JR      BclLzw

;
TstCodeLzw:
;
;       a = inbuffer[ inbytes ];
;
        LD      A,(HL)
        AND     A
;
; Plus d'octets  traiter
; = fini
;
        RET     Z

        INC     HL
        LD      B,A
TstLzw80:
        RLCA
        JR      NC,TstLzw40
;
;       length = 3 + ( ( inbuffer[ inbytes ] >> 4 ) & 7 );
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      L,(HL)
        LD      C,B
        RLCA
        RLCA
        RLCA
        AND     7
        ADD     A,3
        LD      B,A
        LD      A,C
        AND     #0F
        LD      H,A
        LD      C,B
        LD      B,0
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw40:
        RLCA
        JR      NC,TstLzw20
;
;       length = 2;
;       index = inbuffer[ inbytes++ ] & 0x3f;
;       index++;
;
        LD      A,B
        PUSH    HL
        AND     #3F
        LD      L,A
        LD      H,0
        INC     L
        LD      B,D
        LD      C,E
        EX      DE,HL
        SBC     HL,DE
        LD      D,B
        LD      E,C
        LDI
        LDI
        POP     HL
        JR      BclLzw
;
TstLzw20:
        RLCA
        JR      NC,TstLzw10
;
;       length = 2 + ( inbuffer[ inbytes++ ] & 31 );
;       index = inbuffer[ inbytes++ ];
;       index++;
;
        PUSH    HL
        LD      A,B
        LD      L,(HL)
        AND     #1F
        ADD     A,2
        LD      C,A
        LD      H,0
        LD      B,H
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JR      BclLzw
;
TstLzw10:
        RLCA
        JR      NC,CodeLzw00
;
;       index = ( inbuffer[ inbytes++ ] & 15 ) << 8;
;       index |= inbuffer[ inbytes++ ];
;       length = inbuffer[ inbytes++ ] + 1;
;       index++;
;
        LD      A,B
        AND     #0F
        LD      B,(HL)
        INC     HL
        PUSH    HL
        LD      C,(HL)
        LD      H,A
        LD      L,B
        LD      B,0
        INC     BC
        INC     HL
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzw00:
        PUSH    HL
        LD      A,B
        CP      15
        JR      NZ,CodeLzwN15
;
;       length = index = inbuffer[ inbytes+1 ] + 1;
;       inbytes += 2;
;
        LD      C,(HL)
        XOR     A
        LD      B,A
        INC     BC
        LD      H,B
        LD      L,C
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        INC     HL
        JP      BclLzw
;
CodeLzwN15:
        CP      2
        JR      C,CodeLzwInf2
;
;       length = index = inbuffer[ inbytes ];
;
        LD      C,A
        LD      L,A
        XOR     A
        LD      H,A
        LD      B,H
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        JP      BclLzw
;
;       length = index = 256;
;
CodeLzwInf2:
        XOR     A
        LD      B,A
        LD      C,A
        INC     B
        LD      H,B
        LD      L,C
        PUSH    DE
        EX      DE,HL
        SBC     HL,DE
        POP     DE
        LDIR
        POP     HL
        JP      BclLzw
