#ifndef CONVERSION_H
#define CONVERSIOH_H



#define     TAILLE_X    640         // Mode 2 : 640 pixels en largeur

#define     TAILLE_Y    200         // Mode 2 : 200 pixels en hauteur

#define     RATIO_ECRAN 1.6         // (640/200)/2


enum { COMP_R, COMP_V, COMP_B };


#define     TAILLE_BANQUE0      0xA3EF

#define     TAILLE_BANQUES      0x4000


//
// Structure composantes r, v, b (a = inutilis, alignement sur 32 bits )
//
typedef struct
    {
    BYTE b, v, r, a;
    } StRVB;


extern BYTE CharAscii[ 0x800 ];

extern StRVB Tab4C[ 4 ];


void Convert( StRVB * Bitmap
            , BYTE * ImgAscii
            , int Methode
            , int Pct
            , int Matrice
            , int Seuil
            );

unsigned short GenereDiff( BYTE * ImgAscii
                         , BYTE * OldImgAscii
                         , BYTE * DiffAscii
                         , BYTE * NegAscii
                         , int Perte
                         , int UseFrameN
                         );

BOOL CreeBitmap( HDC * DcBitmapImage
               , HBITMAP * bmImage
               , void ** MemBitmapImage
               , HDC hDC
               , int TailleX
               , int TailleY
               );

void DeleteBitmapEcran( HDC DcBitmap, HBITMAP bm );

void InitBank( void );

void EndBank( char * Src, CListBox * Liste );

void AjouteBank( BYTE * Data
               , int l
               , char * Src
               , CListBox * Liste
               , int UseMaxMem
               );

int GetNumBank( void );


#endif
